#define MEMC_BASE		0x10800000

#define ATLAS7_MEMC_SCFG		(MEMC_BASE + 0x000)
#define ATLAS7_MEMC_SCTL		(MEMC_BASE + 0x004)
#define ATLAS7_MEMC_STAT		(MEMC_BASE + 0x008)
#define ATLAS7_MEMC_INTRSTAT		(MEMC_BASE + 0x00c)
#define ATLAS7_MEMC_MCMD		(MEMC_BASE + 0x040)
#define ATLAS7_MEMC_POWCTL		(MEMC_BASE + 0x044)
#define ATLAS7_MEMC_POWSTAT		(MEMC_BASE + 0x048)
#define ATLAS7_MEMC_CMDTSTAT		(MEMC_BASE + 0x04c)
#define ATLAS7_MEMC_CMDTSTATEN		(MEMC_BASE + 0x050)
#define ATLAS7_MEMC_MRRCFG0		(MEMC_BASE + 0x060)
#define ATLAS7_MEMC_MRRSTAT0		(MEMC_BASE + 0x064)
#define ATLAS7_MEMC_MRRSTAT1		(MEMC_BASE + 0x068)
#define ATLAS7_MEMC_MCFG1		(MEMC_BASE + 0x07c)
#define ATLAS7_MEMC_MCFG		(MEMC_BASE + 0x080)
#define ATLAS7_MEMC_PPCFG		(MEMC_BASE + 0x084)
#define ATLAS7_MEMC_MSTAT		(MEMC_BASE + 0x088)
#define ATLAS7_MEMC_LPDDR23ZQCFG		(MEMC_BASE + 0x08c)
#define ATLAS7_MEMC_DTUPDES		(MEMC_BASE + 0x094)
#define ATLAS7_MEMC_DTUNA		(MEMC_BASE + 0x098)
#define ATLAS7_MEMC_DTUNE		(MEMC_BASE + 0x09c)
#define ATLAS7_MEMC_DTUPRD0		(MEMC_BASE + 0x0a0)
#define ATLAS7_MEMC_DTUPRD1		(MEMC_BASE + 0x0a4)
#define ATLAS7_MEMC_DTUPRD2		(MEMC_BASE + 0x0a8)
#define ATLAS7_MEMC_DTUPRD3		(MEMC_BASE + 0x0ac)
#define ATLAS7_MEMC_DTUAWDT		(MEMC_BASE + 0x0b0)
#define ATLAS7_MEMC_TOGCNT1U		(MEMC_BASE + 0x0c0)
#define ATLAS7_MEMC_TINIT		(MEMC_BASE + 0x0c4)
#define ATLAS7_MEMC_TRSTH		(MEMC_BASE + 0x0c8)
#define ATLAS7_MEMC_TOGCNT100N		(MEMC_BASE + 0x0cc)
#define ATLAS7_MEMC_TREFI		(MEMC_BASE + 0x0d0)
#define ATLAS7_MEMC_TMRD		(MEMC_BASE + 0x0d4)
#define ATLAS7_MEMC_TRFC		(MEMC_BASE + 0x0d8)
#define ATLAS7_MEMC_TRP		(MEMC_BASE + 0x0dc)
#define ATLAS7_MEMC_TRTW		(MEMC_BASE + 0x0e0)
#define ATLAS7_MEMC_TAL		(MEMC_BASE + 0x0e4)
#define ATLAS7_MEMC_TCL		(MEMC_BASE + 0x0e8)
#define ATLAS7_MEMC_TCWL		(MEMC_BASE + 0x0ec)
#define ATLAS7_MEMC_TRAS		(MEMC_BASE + 0x0f0)
#define ATLAS7_MEMC_TRC		(MEMC_BASE + 0x0f4)
#define ATLAS7_MEMC_TRCD		(MEMC_BASE + 0x0f8)
#define ATLAS7_MEMC_TRRD		(MEMC_BASE + 0x0fc)
#define ATLAS7_MEMC_TRTP		(MEMC_BASE + 0x100)
#define ATLAS7_MEMC_TWR		(MEMC_BASE + 0x104)
#define ATLAS7_MEMC_TWTR		(MEMC_BASE + 0x108)
#define ATLAS7_MEMC_TEXSR		(MEMC_BASE + 0x10c)
#define ATLAS7_MEMC_TXP		(MEMC_BASE + 0x110)
#define ATLAS7_MEMC_TXPDLL		(MEMC_BASE + 0x114)
#define ATLAS7_MEMC_TZQCS		(MEMC_BASE + 0x118)
#define ATLAS7_MEMC_TZQCSI		(MEMC_BASE + 0x11c)
#define ATLAS7_MEMC_TDQS		(MEMC_BASE + 0x120)
#define ATLAS7_MEMC_TCKSRE		(MEMC_BASE + 0x124)
#define ATLAS7_MEMC_TCKSRX		(MEMC_BASE + 0x128)
#define ATLAS7_MEMC_TCKE		(MEMC_BASE + 0x12c)
#define ATLAS7_MEMC_TMOD		(MEMC_BASE + 0x130)
#define ATLAS7_MEMC_TRSTL		(MEMC_BASE + 0x134)
#define ATLAS7_MEMC_TZQCL		(MEMC_BASE + 0x138)
#define ATLAS7_MEMC_TMRR		(MEMC_BASE + 0x13c)
#define ATLAS7_MEMC_TCKESR		(MEMC_BASE + 0x140)
#define ATLAS7_MEMC_TDPD		(MEMC_BASE + 0x144)
#define ATLAS7_MEMC_TREFI_MEM_DDR3		(MEMC_BASE + 0x148)
#define ATLAS7_MEMC_DTUWACTL		(MEMC_BASE + 0x200)
#define ATLAS7_MEMC_DTURACTL		(MEMC_BASE + 0x204)
#define ATLAS7_MEMC_DTUCFG		(MEMC_BASE + 0x208)
#define ATLAS7_MEMC_DTUECTL		(MEMC_BASE + 0x20c)
#define ATLAS7_MEMC_DTUWD0		(MEMC_BASE + 0x210)
#define ATLAS7_MEMC_DTUWD1		(MEMC_BASE + 0x214)
#define ATLAS7_MEMC_DTUWD2		(MEMC_BASE + 0x218)
#define ATLAS7_MEMC_DTUWD3		(MEMC_BASE + 0x21c)
#define ATLAS7_MEMC_DTUWDM		(MEMC_BASE + 0x220)
#define ATLAS7_MEMC_DTURD0		(MEMC_BASE + 0x224)
#define ATLAS7_MEMC_DTURD1		(MEMC_BASE + 0x228)
#define ATLAS7_MEMC_DTURD2		(MEMC_BASE + 0x22c)
#define ATLAS7_MEMC_DTURD3		(MEMC_BASE + 0x230)
#define ATLAS7_MEMC_DTULFSRWD		(MEMC_BASE + 0x234)
#define ATLAS7_MEMC_DTULFSRRD		(MEMC_BASE + 0x238)
#define ATLAS7_MEMC_DTUEAF		(MEMC_BASE + 0x23c)
#define ATLAS7_MEMC_DFITCTRLDELAY		(MEMC_BASE + 0x240)
#define ATLAS7_MEMC_DFIODTCFG		(MEMC_BASE + 0x244)
#define ATLAS7_MEMC_DFIODTCFG1		(MEMC_BASE + 0x248)
#define ATLAS7_MEMC_DFIODTRANKMAP		(MEMC_BASE + 0x24c)
#define ATLAS7_MEMC_DFITPHYWRDATA		(MEMC_BASE + 0x250)
#define ATLAS7_MEMC_DFITPHYWRLAT		(MEMC_BASE + 0x254)
#define ATLAS7_MEMC_DFITPHYWRDATALAT		(MEMC_BASE + 0x258)
#define ATLAS7_MEMC_DFITRDDATAEN		(MEMC_BASE + 0x260)
#define ATLAS7_MEMC_DFITPHYRDLAT		(MEMC_BASE + 0x264)
#define ATLAS7_MEMC_DFITPHYUPDTYPE0		(MEMC_BASE + 0x270)
#define ATLAS7_MEMC_DFITPHYUPDTYPE1		(MEMC_BASE + 0x274)
#define ATLAS7_MEMC_DFITPHYUPDTYPE2		(MEMC_BASE + 0x278)
#define ATLAS7_MEMC_DFITPHYUPDTYPE3		(MEMC_BASE + 0x27c)
#define ATLAS7_MEMC_DFITCTRLUPDMIN		(MEMC_BASE + 0x280)
#define ATLAS7_MEMC_DFITCTRLUPDMAX		(MEMC_BASE + 0x284)
#define ATLAS7_MEMC_DFITCTRLUPDDLY		(MEMC_BASE + 0x288)
#define ATLAS7_MEMC_DFIUPDCFG		(MEMC_BASE + 0x290)
#define ATLAS7_MEMC_DFITREFMSKI		(MEMC_BASE + 0x294)
#define ATLAS7_MEMC_DFITCTRLUPDI		(MEMC_BASE + 0x298)
#define ATLAS7_MEMC_DFITRCFG0		(MEMC_BASE + 0x2ac)
#define ATLAS7_MEMC_DFITRSTAT0		(MEMC_BASE + 0x2b0)
#define ATLAS7_MEMC_DFITRWRLVLEN		(MEMC_BASE + 0x2b4)
#define ATLAS7_MEMC_DFITRRDLVLEN		(MEMC_BASE + 0x2b8)
#define ATLAS7_MEMC_DFITRRDLVLGATEEN		(MEMC_BASE + 0x2bc)
#define ATLAS7_MEMC_DFISTSTAT0		(MEMC_BASE + 0x2c0)
#define ATLAS7_MEMC_DFISTCFG0		(MEMC_BASE + 0x2c4)
#define ATLAS7_MEMC_DFISTCFG1		(MEMC_BASE + 0x2c8)
#define ATLAS7_MEMC_DFITDRAMCLKEN		(MEMC_BASE + 0x2d0)
#define ATLAS7_MEMC_DFITDRAMCLKDIS		(MEMC_BASE + 0x2d4)
#define ATLAS7_MEMC_DFISTCFG2		(MEMC_BASE + 0x2d8)
#define ATLAS7_MEMC_DFISTPARCLR		(MEMC_BASE + 0x2dc)
#define ATLAS7_MEMC_DFISTPARLOG		(MEMC_BASE + 0x2e0)
#define ATLAS7_MEMC_DFILPCFG0		(MEMC_BASE + 0x2f0)
#define ATLAS7_MEMC_DFITRWRLVLRESP0		(MEMC_BASE + 0x300)
#define ATLAS7_MEMC_DFITRWRLVLRESP1		(MEMC_BASE + 0x304)
#define ATLAS7_MEMC_DFITRWRLVLRESP2		(MEMC_BASE + 0x308)
#define ATLAS7_MEMC_DFITRRDLVLRESP0		(MEMC_BASE + 0x30c)
#define ATLAS7_MEMC_DFITRRDLVLRESP1		(MEMC_BASE + 0x310)
#define ATLAS7_MEMC_DFITRRDLVLRESP2		(MEMC_BASE + 0x314)
#define ATLAS7_MEMC_DFITRWRLVLDELAY0		(MEMC_BASE + 0x318)
#define ATLAS7_MEMC_DFITRRDLVLDELAY0		(MEMC_BASE + 0x324)
#define ATLAS7_MEMC_DFITRRDLVLGATEDELAY0		(MEMC_BASE + 0x330)
#define ATLAS7_MEMC_DFITRCMD		(MEMC_BASE + 0x33c)
#define ATLAS7_MEMC_IPVR		(MEMC_BASE + 0x3f8)
#define ATLAS7_MEMC_IPTR		(MEMC_BASE + 0x3fc)

/* fields for register ATLAS7_MEMC_SCFG */
#define ATLAS7_MEMC_SCFG_HW_LOW_POWER_EN		BIT(0)
#define ATLAS7_MEMC_SCFG_NFIFO_NIF1_DIS		BIT(6)
#define ATLAS7_MEMC_SCFG_AC_PDD_EN		BIT(7)
#define ATLAS7_MEMC_SCFG_BBFLAGS_TIMING_MASK		0xf
#define ATLAS7_MEMC_SCFG_BBFLAGS_TIMING_SHIFT		8
#define ATLAS7_MEMC_SCFG_AC_PDD_ADD_DEL_MASK		0x1f
#define ATLAS7_MEMC_SCFG_AC_PDD_ADD_DEL_SHIFT		12

/* fields for register ATLAS7_MEMC_SCTL */
#define ATLAS7_MEMC_SCTL_STATE_CMD_MASK		0x7
#define ATLAS7_MEMC_SCTL_STATE_CMD_SHIFT		0

/* fields for register ATLAS7_MEMC_STAT */
#define ATLAS7_MEMC_STAT_CTL_STAT_MASK		0x7
#define ATLAS7_MEMC_STAT_CTL_STAT_SHIFT		0
#define ATLAS7_MEMC_STAT_LP_TRIG_MASK		0x7
#define ATLAS7_MEMC_STAT_LP_TRIG_SHIFT		4

/* fields for register ATLAS7_MEMC_INTRSTAT */
#define ATLAS7_MEMC_INTRSTAT_ECC_INTR		BIT(0)
#define ATLAS7_MEMC_INTRSTAT_PARITY_INTR		BIT(1)

/* fields for register ATLAS7_MEMC_MCMD */
#define ATLAS7_MEMC_MCMD_CMD_OPCODE_MASK		0xf
#define ATLAS7_MEMC_MCMD_CMD_OPCODE_SHIFT		0
#define ATLAS7_MEMC_MCMD_CMD_ADDR_MASK		0x1fff
#define ATLAS7_MEMC_MCMD_CMD_ADDR_SHIFT		4
#define ATLAS7_MEMC_MCMD_BANK_ADDR_MASK		0x7
#define ATLAS7_MEMC_MCMD_BANK_ADDR_SHIFT		17
#define ATLAS7_MEMC_MCMD_RANK_SEL_MASK		0xf
#define ATLAS7_MEMC_MCMD_RANK_SEL_SHIFT		20
#define ATLAS7_MEMC_MCMD_CMD_ADD_DEL_MASK		0xf
#define ATLAS7_MEMC_MCMD_CMD_ADD_DEL_SHIFT		24
#define ATLAS7_MEMC_MCMD_START_CMD		BIT(31)

/* fields for register ATLAS7_MEMC_POWCTL */
#define ATLAS7_MEMC_POWCTL_POWER_UP_START		BIT(0)

/* fields for register ATLAS7_MEMC_POWSTAT */
#define ATLAS7_MEMC_POWSTAT_POWER_UP_DONE		BIT(0)

/* fields for register ATLAS7_MEMC_CMDTSTAT */
#define ATLAS7_MEMC_CMDTSTAT_CMD_TIMERS_STAT		BIT(0)

/* fields for register ATLAS7_MEMC_CMDTSTATEN */
#define ATLAS7_MEMC_CMDTSTATEN_CMD_TIMERS_STAT_EN		BIT(0)

/* fields for register ATLAS7_MEMC_MRRCFG0 */
#define ATLAS7_MEMC_MRRCFG0_MRR_BYTE_SEL_MASK		0xf
#define ATLAS7_MEMC_MRRCFG0_MRR_BYTE_SEL_SHIFT		0

/* fields for register ATLAS7_MEMC_MRRSTAT0 */
#define ATLAS7_MEMC_MRRSTAT0_MRR_BEAT0_MASK		0xff
#define ATLAS7_MEMC_MRRSTAT0_MRR_BEAT0_SHIFT		0
#define ATLAS7_MEMC_MRRSTAT0_MRR_BEAT1_MASK		0xff
#define ATLAS7_MEMC_MRRSTAT0_MRR_BEAT1_SHIFT		8
#define ATLAS7_MEMC_MRRSTAT0_MRR_BEAT2_MASK		0xff
#define ATLAS7_MEMC_MRRSTAT0_MRR_BEAT2_SHIFT		16
#define ATLAS7_MEMC_MRRSTAT0_MRR_BEAT3_MASK		0xff
#define ATLAS7_MEMC_MRRSTAT0_MRR_BEAT3_SHIFT		24

/* fields for register ATLAS7_MEMC_MRRSTAT1 */
#define ATLAS7_MEMC_MRRSTAT1_MRR_BEAT4_MASK		0xff
#define ATLAS7_MEMC_MRRSTAT1_MRR_BEAT4_SHIFT		0
#define ATLAS7_MEMC_MRRSTAT1_MRR_BEAT5_MASK		0xff
#define ATLAS7_MEMC_MRRSTAT1_MRR_BEAT5_SHIFT		8
#define ATLAS7_MEMC_MRRSTAT1_MRR_BEAT6_MASK		0xff
#define ATLAS7_MEMC_MRRSTAT1_MRR_BEAT6_SHIFT		16
#define ATLAS7_MEMC_MRRSTAT1_MRR_BEAT7_MASK		0xff
#define ATLAS7_MEMC_MRRSTAT1_MRR_BEAT7_SHIFT		24

/* fields for register ATLAS7_MEMC_MCFG1 */
#define ATLAS7_MEMC_MCFG1_SR_IDLE_MASK		0xff
#define ATLAS7_MEMC_MCFG1_SR_IDLE_SHIFT		0
#define ATLAS7_MEMC_MCFG1_TFAW_CFG_OFFSET_MASK		0x7
#define ATLAS7_MEMC_MCFG1_TFAW_CFG_OFFSET_SHIFT		8
#define ATLAS7_MEMC_MCFG1_HW_IDLE_MASK		0xff
#define ATLAS7_MEMC_MCFG1_HW_IDLE_SHIFT		16
#define ATLAS7_MEMC_MCFG1_ZQ_RESISTOR_SHARED		BIT(24)
#define ATLAS7_MEMC_MCFG1_HW_EXIT_IDLE_EN		BIT(31)

/* fields for register ATLAS7_MEMC_MCFG */
#define ATLAS7_MEMC_MCFG_MEM_BL		BIT(0)
#define ATLAS7_MEMC_MCFG_CKE_OR_EN		BIT(1)
#define ATLAS7_MEMC_MCFG_BL8INT_EN		BIT(2)
#define ATLAS7_MEMC_MCFG_TWO_T_EN		BIT(3)
#define ATLAS7_MEMC_MCFG_STAGGER_CS		BIT(4)
#define ATLAS7_MEMC_MCFG_DDR3_EN		BIT(5)
#define ATLAS7_MEMC_MCFG_LPDDR2_S4		BIT(6)
#define ATLAS7_MEMC_MCFG_MDDR_LPDDR23_BST_EVEN		BIT(7)
#define ATLAS7_MEMC_MCFG_PD_IDLE_MASK		0xff
#define ATLAS7_MEMC_MCFG_PD_IDLE_SHIFT		8
#define ATLAS7_MEMC_MCFG_PD_TYPE		BIT(16)
#define ATLAS7_MEMC_MCFG_PD_EXIT_MODE		BIT(17)
#define ATLAS7_MEMC_MCFG_TFAW_CFG_MASK		0x3
#define ATLAS7_MEMC_MCFG_TFAW_CFG_SHIFT		18
#define ATLAS7_MEMC_MCFG_MDDR_LPDDR23_BL_MASK		0x3
#define ATLAS7_MEMC_MCFG_MDDR_LPDDR23_BL_SHIFT		20
#define ATLAS7_MEMC_MCFG_MDDR_LPDDR23_EN_MASK		0x3
#define ATLAS7_MEMC_MCFG_MDDR_LPDDR23_EN_SHIFT		22
#define ATLAS7_MEMC_MCFG_MDDR_LPDDR23_CLKSTOP_IDLE_MASK		0xff
#define ATLAS7_MEMC_MCFG_MDDR_LPDDR23_CLKSTOP_IDLE_SHIFT		24

/* fields for register ATLAS7_MEMC_PPCFG */
#define ATLAS7_MEMC_PPCFG_PPMEM_EN		BIT(0)
#define ATLAS7_MEMC_PPCFG_RPMEM_DIS_MASK		0xff
#define ATLAS7_MEMC_PPCFG_RPMEM_DIS_SHIFT		1
#define ATLAS7_MEMC_PPCFG_QPMEM_EN		BIT(16)

/* fields for register ATLAS7_MEMC_MSTAT */
#define ATLAS7_MEMC_MSTAT_POWER_DOWN		BIT(0)
#define ATLAS7_MEMC_MSTAT_CLOCK_STOP		BIT(1)
#define ATLAS7_MEMC_MSTAT_SELF_REFRESH		BIT(2)

/* fields for register ATLAS7_MEMC_LPDDR23ZQCFG */
#define ATLAS7_MEMC_LPDDR23ZQCFG_ZQCS_MA_MASK		0xff
#define ATLAS7_MEMC_LPDDR23ZQCFG_ZQCS_MA_SHIFT		0
#define ATLAS7_MEMC_LPDDR23ZQCFG_ZQCS_OP_MASK		0xff
#define ATLAS7_MEMC_LPDDR23ZQCFG_ZQCS_OP_SHIFT		8
#define ATLAS7_MEMC_LPDDR23ZQCFG_ZQCL_MA_MASK		0xff
#define ATLAS7_MEMC_LPDDR23ZQCFG_ZQCL_MA_SHIFT		16
#define ATLAS7_MEMC_LPDDR23ZQCFG_ZQCL_OP_MASK		0xff
#define ATLAS7_MEMC_LPDDR23ZQCFG_ZQCL_OP_SHIFT		24

/* fields for register ATLAS7_MEMC_DTUPDES */
#define ATLAS7_MEMC_DTUPDES_DTU_ERR_B0		BIT(0)
#define ATLAS7_MEMC_DTUPDES_DTU_ERR_B1		BIT(1)
#define ATLAS7_MEMC_DTUPDES_DTU_ERR_B2		BIT(2)
#define ATLAS7_MEMC_DTUPDES_DTU_ERR_B3		BIT(3)
#define ATLAS7_MEMC_DTUPDES_DTU_ERR_B4		BIT(4)
#define ATLAS7_MEMC_DTUPDES_DTU_ERR_B5		BIT(5)
#define ATLAS7_MEMC_DTUPDES_DTU_ERR_B6		BIT(6)
#define ATLAS7_MEMC_DTUPDES_DTU_ERR_B7		BIT(7)
#define ATLAS7_MEMC_DTUPDES_DTU_RANDOM_ERROR		BIT(8)
#define ATLAS7_MEMC_DTUPDES_DTU_EAFFL_MASK		0xf
#define ATLAS7_MEMC_DTUPDES_DTU_EAFFL_SHIFT		9
#define ATLAS7_MEMC_DTUPDES_DTU_RD_BEAT_MISSING		BIT(13)

/* fields for register ATLAS7_MEMC_DTUNA */
#define ATLAS7_MEMC_DTUNA_DTU_NUM_ADDRESS_MASK		0xffffffff
#define ATLAS7_MEMC_DTUNA_DTU_NUM_ADDRESS_SHIFT		0

/* fields for register ATLAS7_MEMC_DTUNE */
#define ATLAS7_MEMC_DTUNE_DTU_NUM_ERRORS_MASK		0xffffffff
#define ATLAS7_MEMC_DTUNE_DTU_NUM_ERRORS_SHIFT		0

/* fields for register ATLAS7_MEMC_DTUPRD0 */
#define ATLAS7_MEMC_DTUPRD0_DTU_ALLBITS_0_MASK		0xffff
#define ATLAS7_MEMC_DTUPRD0_DTU_ALLBITS_0_SHIFT		0
#define ATLAS7_MEMC_DTUPRD0_DTU_ALLBITS_1_MASK		0xffff
#define ATLAS7_MEMC_DTUPRD0_DTU_ALLBITS_1_SHIFT		16

/* fields for register ATLAS7_MEMC_DTUPRD1 */
#define ATLAS7_MEMC_DTUPRD1_DTU_ALLBITS_2_MASK		0xffff
#define ATLAS7_MEMC_DTUPRD1_DTU_ALLBITS_2_SHIFT		0
#define ATLAS7_MEMC_DTUPRD1_DTU_ALLBITS_3_MASK		0xffff
#define ATLAS7_MEMC_DTUPRD1_DTU_ALLBITS_3_SHIFT		16

/* fields for register ATLAS7_MEMC_DTUPRD2 */
#define ATLAS7_MEMC_DTUPRD2_DTU_ALLBITS_4_MASK		0xffff
#define ATLAS7_MEMC_DTUPRD2_DTU_ALLBITS_4_SHIFT		0
#define ATLAS7_MEMC_DTUPRD2_DTU_ALLBITS_5_MASK		0xffff
#define ATLAS7_MEMC_DTUPRD2_DTU_ALLBITS_5_SHIFT		16

/* fields for register ATLAS7_MEMC_DTUPRD3 */
#define ATLAS7_MEMC_DTUPRD3_DTU_ALLBITS_6_MASK		0xffff
#define ATLAS7_MEMC_DTUPRD3_DTU_ALLBITS_6_SHIFT		0
#define ATLAS7_MEMC_DTUPRD3_DTU_ALLBITS_7_MASK		0xffff
#define ATLAS7_MEMC_DTUPRD3_DTU_ALLBITS_7_SHIFT		16

/* fields for register ATLAS7_MEMC_DTUAWDT */
#define ATLAS7_MEMC_DTUAWDT_COLUMN_ADDR_WIDTH_MASK		0x3
#define ATLAS7_MEMC_DTUAWDT_COLUMN_ADDR_WIDTH_SHIFT		0
#define ATLAS7_MEMC_DTUAWDT_BANK_ADDR_WIDTH_MASK		0x3
#define ATLAS7_MEMC_DTUAWDT_BANK_ADDR_WIDTH_SHIFT		3
#define ATLAS7_MEMC_DTUAWDT_ROW_ADDR_WIDTH_MASK		0x3
#define ATLAS7_MEMC_DTUAWDT_ROW_ADDR_WIDTH_SHIFT		6
#define ATLAS7_MEMC_DTUAWDT_NUMBER_RANKS_MASK		0x3
#define ATLAS7_MEMC_DTUAWDT_NUMBER_RANKS_SHIFT		9

/* fields for register ATLAS7_MEMC_TOGCNT1U */
#define ATLAS7_MEMC_TOGCNT1U_TOGGLE_COUNTER_1U_MASK		0x3ff
#define ATLAS7_MEMC_TOGCNT1U_TOGGLE_COUNTER_1U_SHIFT		0

/* fields for register ATLAS7_MEMC_TINIT */
#define ATLAS7_MEMC_TINIT_T_INIT_MASK		0x1ff
#define ATLAS7_MEMC_TINIT_T_INIT_SHIFT		0

/* fields for register ATLAS7_MEMC_TRSTH */
#define ATLAS7_MEMC_TRSTH_T_RSTH_MASK		0x3ff
#define ATLAS7_MEMC_TRSTH_T_RSTH_SHIFT		0

/* fields for register ATLAS7_MEMC_TOGCNT100N */
#define ATLAS7_MEMC_TOGCNT100N_TOGGLE_COUNTER_100N_MASK		0x7f
#define ATLAS7_MEMC_TOGCNT100N_TOGGLE_COUNTER_100N_SHIFT		0

/* fields for register ATLAS7_MEMC_TREFI */
#define ATLAS7_MEMC_TREFI_T_REFI_MASK		0x1fff
#define ATLAS7_MEMC_TREFI_T_REFI_SHIFT		0
#define ATLAS7_MEMC_TREFI_NUM_ADD_REF_MASK		0x7
#define ATLAS7_MEMC_TREFI_NUM_ADD_REF_SHIFT		16
#define ATLAS7_MEMC_TREFI_UPD_REF		BIT(31)

/* fields for register ATLAS7_MEMC_TMRD */
#define ATLAS7_MEMC_TMRD_T_MRD_MASK		0x7
#define ATLAS7_MEMC_TMRD_T_MRD_SHIFT		0

/* fields for register ATLAS7_MEMC_TRFC */
#define ATLAS7_MEMC_TRFC_T_RFC_MASK		0x1ff
#define ATLAS7_MEMC_TRFC_T_RFC_SHIFT		0

/* fields for register ATLAS7_MEMC_TRP */
#define ATLAS7_MEMC_TRP_T_RP_MASK		0x1f
#define ATLAS7_MEMC_TRP_T_RP_SHIFT		0
#define ATLAS7_MEMC_TRP_PREA_EXTRA_MASK		0x3
#define ATLAS7_MEMC_TRP_PREA_EXTRA_SHIFT		16

/* fields for register ATLAS7_MEMC_TRTW */
#define ATLAS7_MEMC_TRTW_T_RTW_MASK		0xf
#define ATLAS7_MEMC_TRTW_T_RTW_SHIFT		0

/* fields for register ATLAS7_MEMC_TAL */
#define ATLAS7_MEMC_TAL_T_AL_MASK		0xf
#define ATLAS7_MEMC_TAL_T_AL_SHIFT		0

/* fields for register ATLAS7_MEMC_TCL */
#define ATLAS7_MEMC_TCL_T_CL_MASK		0xf
#define ATLAS7_MEMC_TCL_T_CL_SHIFT		0

/* fields for register ATLAS7_MEMC_TCWL */
#define ATLAS7_MEMC_TCWL_T_CWL_MASK		0xf
#define ATLAS7_MEMC_TCWL_T_CWL_SHIFT		0

/* fields for register ATLAS7_MEMC_TRAS */
#define ATLAS7_MEMC_TRAS_T_RAS_MASK		0x3f
#define ATLAS7_MEMC_TRAS_T_RAS_SHIFT		0

/* fields for register ATLAS7_MEMC_TRC */
#define ATLAS7_MEMC_TRC_T_RC_MASK		0x3f
#define ATLAS7_MEMC_TRC_T_RC_SHIFT		0

/* fields for register ATLAS7_MEMC_TRCD */
#define ATLAS7_MEMC_TRCD_T_RCD_MASK		0x1f
#define ATLAS7_MEMC_TRCD_T_RCD_SHIFT		0

/* fields for register ATLAS7_MEMC_TRRD */
#define ATLAS7_MEMC_TRRD_T_RRD_MASK		0xf
#define ATLAS7_MEMC_TRRD_T_RRD_SHIFT		0

/* fields for register ATLAS7_MEMC_TRTP */
#define ATLAS7_MEMC_TRTP_T_RTP_MASK		0xf
#define ATLAS7_MEMC_TRTP_T_RTP_SHIFT		0

/* fields for register ATLAS7_MEMC_TWR */
#define ATLAS7_MEMC_TWR_T_WR_MASK		0x1f
#define ATLAS7_MEMC_TWR_T_WR_SHIFT		0

/* fields for register ATLAS7_MEMC_TWTR */
#define ATLAS7_MEMC_TWTR_T_WTR_MASK		0xf
#define ATLAS7_MEMC_TWTR_T_WTR_SHIFT		0

/* fields for register ATLAS7_MEMC_TEXSR */
#define ATLAS7_MEMC_TEXSR_T_EXSR_MASK		0x3ff
#define ATLAS7_MEMC_TEXSR_T_EXSR_SHIFT		0

/* fields for register ATLAS7_MEMC_TXP */
#define ATLAS7_MEMC_TXP_T_XP_MASK		0x7
#define ATLAS7_MEMC_TXP_T_XP_SHIFT		0

/* fields for register ATLAS7_MEMC_TXPDLL */
#define ATLAS7_MEMC_TXPDLL_T_XPDLL_MASK		0x3f
#define ATLAS7_MEMC_TXPDLL_T_XPDLL_SHIFT		0

/* fields for register ATLAS7_MEMC_TZQCS */
#define ATLAS7_MEMC_TZQCS_T_ZQCS_MASK		0x7f
#define ATLAS7_MEMC_TZQCS_T_ZQCS_SHIFT		0

/* fields for register ATLAS7_MEMC_TZQCSI */
#define ATLAS7_MEMC_TZQCSI_T_ZQCSI_MASK		0xffffffff
#define ATLAS7_MEMC_TZQCSI_T_ZQCSI_SHIFT		0

/* fields for register ATLAS7_MEMC_TDQS */
#define ATLAS7_MEMC_TDQS_T_DQS_MASK		0xf
#define ATLAS7_MEMC_TDQS_T_DQS_SHIFT		0

/* fields for register ATLAS7_MEMC_TCKSRE */
#define ATLAS7_MEMC_TCKSRE_T_CKSRE_MASK		0x1f
#define ATLAS7_MEMC_TCKSRE_T_CKSRE_SHIFT		0

/* fields for register ATLAS7_MEMC_TCKSRX */
#define ATLAS7_MEMC_TCKSRX_T_CKSRX_MASK		0x1f
#define ATLAS7_MEMC_TCKSRX_T_CKSRX_SHIFT		0

/* fields for register ATLAS7_MEMC_TCKE */
#define ATLAS7_MEMC_TCKE_T_CKE_MASK		0x7
#define ATLAS7_MEMC_TCKE_T_CKE_SHIFT		0

/* fields for register ATLAS7_MEMC_TMOD */
#define ATLAS7_MEMC_TMOD_T_MOD_MASK		0x1f
#define ATLAS7_MEMC_TMOD_T_MOD_SHIFT		0

/* fields for register ATLAS7_MEMC_TRSTL */
#define ATLAS7_MEMC_TRSTL_T_RSTL_MASK		0x7f
#define ATLAS7_MEMC_TRSTL_T_RSTL_SHIFT		0

/* fields for register ATLAS7_MEMC_TZQCL */
#define ATLAS7_MEMC_TZQCL_T_ZQCL_MASK		0x3ff
#define ATLAS7_MEMC_TZQCL_T_ZQCL_SHIFT		0

/* fields for register ATLAS7_MEMC_TMRR */
#define ATLAS7_MEMC_TMRR_T_MRR_MASK		0xff
#define ATLAS7_MEMC_TMRR_T_MRR_SHIFT		0

/* fields for register ATLAS7_MEMC_TCKESR */
#define ATLAS7_MEMC_TCKESR_T_CKESR_MASK		0xf
#define ATLAS7_MEMC_TCKESR_T_CKESR_SHIFT		0

/* fields for register ATLAS7_MEMC_TDPD */
#define ATLAS7_MEMC_TDPD_T_DPD_MASK		0x3ff
#define ATLAS7_MEMC_TDPD_T_DPD_SHIFT		0

/* fields for register ATLAS7_MEMC_TREFI_MEM_DDR3 */
#define ATLAS7_MEMC_TREFI_MEM_DDR3_MEM_TREFI_DDDR3_MASK		0x7fff
#define ATLAS7_MEMC_TREFI_MEM_DDR3_MEM_TREFI_DDDR3_SHIFT		0

/* fields for register ATLAS7_MEMC_DTUWACTL */
#define ATLAS7_MEMC_DTUWACTL_DTU_WR_COL_MASK		0x3ff
#define ATLAS7_MEMC_DTUWACTL_DTU_WR_COL_SHIFT		0
#define ATLAS7_MEMC_DTUWACTL_DTU_WR_BANK_MASK		0x7
#define ATLAS7_MEMC_DTUWACTL_DTU_WR_BANK_SHIFT		10
#define ATLAS7_MEMC_DTUWACTL_DTU_WR_ROW_MASK		0xffff
#define ATLAS7_MEMC_DTUWACTL_DTU_WR_ROW_SHIFT		13
#define ATLAS7_MEMC_DTUWACTL_DTU_WR_RANK_MASK		0x3
#define ATLAS7_MEMC_DTUWACTL_DTU_WR_RANK_SHIFT		30

/* fields for register ATLAS7_MEMC_DTURACTL */
#define ATLAS7_MEMC_DTURACTL_DTU_RD_COL_MASK		0x3ff
#define ATLAS7_MEMC_DTURACTL_DTU_RD_COL_SHIFT		0
#define ATLAS7_MEMC_DTURACTL_DTU_RD_BANK_MASK		0x7
#define ATLAS7_MEMC_DTURACTL_DTU_RD_BANK_SHIFT		10
#define ATLAS7_MEMC_DTURACTL_DTU_RD_ROW_MASK		0xffff
#define ATLAS7_MEMC_DTURACTL_DTU_RD_ROW_SHIFT		13
#define ATLAS7_MEMC_DTURACTL_DTU_RD_RANK_MASK		0x3
#define ATLAS7_MEMC_DTURACTL_DTU_RD_RANK_SHIFT		30

/* fields for register ATLAS7_MEMC_DTUCFG */
#define ATLAS7_MEMC_DTUCFG_DTU_ENABLE		BIT(0)
#define ATLAS7_MEMC_DTUCFG_DTU_NALEN_MASK		0x3f
#define ATLAS7_MEMC_DTUCFG_DTU_NALEN_SHIFT		1
#define ATLAS7_MEMC_DTUCFG_DTU_INCR_COLS		BIT(7)
#define ATLAS7_MEMC_DTUCFG_DTU_INCR_BANKS		BIT(8)
#define ATLAS7_MEMC_DTUCFG_DTU_GENERATE_RANDOM		BIT(9)
#define ATLAS7_MEMC_DTUCFG_DTU_TARGET_LANE_MASK		0xf
#define ATLAS7_MEMC_DTUCFG_DTU_TARGET_LANE_SHIFT		10
#define ATLAS7_MEMC_DTUCFG_DTU_DATA_MASK_EN		BIT(14)
#define ATLAS7_MEMC_DTUCFG_DTU_WR_MULTI_RD		BIT(15)
#define ATLAS7_MEMC_DTUCFG_DTU_ROW_INCREMENTS_MASK		0x7f
#define ATLAS7_MEMC_DTUCFG_DTU_ROW_INCREMENTS_SHIFT		16

/* fields for register ATLAS7_MEMC_DTUECTL */
#define ATLAS7_MEMC_DTUECTL_RUN_DTU		BIT(0)
#define ATLAS7_MEMC_DTUECTL_RUN_ERR_REPORTS		BIT(1)
#define ATLAS7_MEMC_DTUECTL_WR_MULTI_RD_RST		BIT(2)

/* fields for register ATLAS7_MEMC_DTUWD0 */
#define ATLAS7_MEMC_DTUWD0_DTU_WR_BYTE0_MASK		0xff
#define ATLAS7_MEMC_DTUWD0_DTU_WR_BYTE0_SHIFT		0
#define ATLAS7_MEMC_DTUWD0_DTU_WR_BYTE1_MASK		0xff
#define ATLAS7_MEMC_DTUWD0_DTU_WR_BYTE1_SHIFT		8
#define ATLAS7_MEMC_DTUWD0_DTU_WR_BYTE2_MASK		0xff
#define ATLAS7_MEMC_DTUWD0_DTU_WR_BYTE2_SHIFT		16
#define ATLAS7_MEMC_DTUWD0_DTU_WR_BYTE3_MASK		0xff
#define ATLAS7_MEMC_DTUWD0_DTU_WR_BYTE3_SHIFT		24

/* fields for register ATLAS7_MEMC_DTUWD1 */
#define ATLAS7_MEMC_DTUWD1_DTU_WR_BYTE4_MASK		0xff
#define ATLAS7_MEMC_DTUWD1_DTU_WR_BYTE4_SHIFT		0
#define ATLAS7_MEMC_DTUWD1_DTU_WR_BYTE5_MASK		0xff
#define ATLAS7_MEMC_DTUWD1_DTU_WR_BYTE5_SHIFT		8
#define ATLAS7_MEMC_DTUWD1_DTU_WR_BYTE6_MASK		0xff
#define ATLAS7_MEMC_DTUWD1_DTU_WR_BYTE6_SHIFT		16
#define ATLAS7_MEMC_DTUWD1_DTU_WR_BYTE7_MASK		0xff
#define ATLAS7_MEMC_DTUWD1_DTU_WR_BYTE7_SHIFT		24

/* fields for register ATLAS7_MEMC_DTUWD2 */
#define ATLAS7_MEMC_DTUWD2_DTU_WR_BYTE8_MASK		0xff
#define ATLAS7_MEMC_DTUWD2_DTU_WR_BYTE8_SHIFT		0
#define ATLAS7_MEMC_DTUWD2_DTU_WR_BYTE9_MASK		0xff
#define ATLAS7_MEMC_DTUWD2_DTU_WR_BYTE9_SHIFT		8
#define ATLAS7_MEMC_DTUWD2_DTU_WR_BYTE10_MASK		0xff
#define ATLAS7_MEMC_DTUWD2_DTU_WR_BYTE10_SHIFT		16
#define ATLAS7_MEMC_DTUWD2_DTU_WR_BYTE11_MASK		0xff
#define ATLAS7_MEMC_DTUWD2_DTU_WR_BYTE11_SHIFT		24

/* fields for register ATLAS7_MEMC_DTUWD3 */
#define ATLAS7_MEMC_DTUWD3_DTU_WR_BYTE12_MASK		0xff
#define ATLAS7_MEMC_DTUWD3_DTU_WR_BYTE12_SHIFT		0
#define ATLAS7_MEMC_DTUWD3_DTU_WR_BYTE13_MASK		0xff
#define ATLAS7_MEMC_DTUWD3_DTU_WR_BYTE13_SHIFT		8
#define ATLAS7_MEMC_DTUWD3_DTU_WR_BYTE14_MASK		0xff
#define ATLAS7_MEMC_DTUWD3_DTU_WR_BYTE14_SHIFT		16
#define ATLAS7_MEMC_DTUWD3_DTU_WR_BYTE15_MASK		0xff
#define ATLAS7_MEMC_DTUWD3_DTU_WR_BYTE15_SHIFT		24

/* fields for register ATLAS7_MEMC_DTUWDM */
#define ATLAS7_MEMC_DTUWDM_DM_WR_BYTE_MASK		0xffff
#define ATLAS7_MEMC_DTUWDM_DM_WR_BYTE_SHIFT		0

/* fields for register ATLAS7_MEMC_DTURD0 */
#define ATLAS7_MEMC_DTURD0_DTU_RD_BYTE0_MASK		0xff
#define ATLAS7_MEMC_DTURD0_DTU_RD_BYTE0_SHIFT		0
#define ATLAS7_MEMC_DTURD0_DTU_RD_BYTE1_MASK		0xff
#define ATLAS7_MEMC_DTURD0_DTU_RD_BYTE1_SHIFT		8
#define ATLAS7_MEMC_DTURD0_DTU_RD_BYTE2_MASK		0xff
#define ATLAS7_MEMC_DTURD0_DTU_RD_BYTE2_SHIFT		16
#define ATLAS7_MEMC_DTURD0_DTU_RD_BYTE3_MASK		0xff
#define ATLAS7_MEMC_DTURD0_DTU_RD_BYTE3_SHIFT		24

/* fields for register ATLAS7_MEMC_DTURD1 */
#define ATLAS7_MEMC_DTURD1_DTU_RD_BYTE4_MASK		0xff
#define ATLAS7_MEMC_DTURD1_DTU_RD_BYTE4_SHIFT		0
#define ATLAS7_MEMC_DTURD1_DTU_RD_BYTE5_MASK		0xff
#define ATLAS7_MEMC_DTURD1_DTU_RD_BYTE5_SHIFT		8
#define ATLAS7_MEMC_DTURD1_DTU_RD_BYTE6_MASK		0xff
#define ATLAS7_MEMC_DTURD1_DTU_RD_BYTE6_SHIFT		16
#define ATLAS7_MEMC_DTURD1_DTU_RD_BYTE7_MASK		0xff
#define ATLAS7_MEMC_DTURD1_DTU_RD_BYTE7_SHIFT		24

/* fields for register ATLAS7_MEMC_DTURD2 */
#define ATLAS7_MEMC_DTURD2_DTU_RD_BYTE8_MASK		0xff
#define ATLAS7_MEMC_DTURD2_DTU_RD_BYTE8_SHIFT		0
#define ATLAS7_MEMC_DTURD2_DTU_RD_BYTE9_MASK		0xff
#define ATLAS7_MEMC_DTURD2_DTU_RD_BYTE9_SHIFT		8
#define ATLAS7_MEMC_DTURD2_DTU_RD_BYTE10_MASK		0xff
#define ATLAS7_MEMC_DTURD2_DTU_RD_BYTE10_SHIFT		16
#define ATLAS7_MEMC_DTURD2_DTU_RD_BYTE11_MASK		0xff
#define ATLAS7_MEMC_DTURD2_DTU_RD_BYTE11_SHIFT		24

/* fields for register ATLAS7_MEMC_DTURD3 */
#define ATLAS7_MEMC_DTURD3_DTU_RD_BYTE12_MASK		0xff
#define ATLAS7_MEMC_DTURD3_DTU_RD_BYTE12_SHIFT		0
#define ATLAS7_MEMC_DTURD3_DTU_RD_BYTE13_MASK		0xff
#define ATLAS7_MEMC_DTURD3_DTU_RD_BYTE13_SHIFT		8
#define ATLAS7_MEMC_DTURD3_DTU_RD_BYTE14_MASK		0xff
#define ATLAS7_MEMC_DTURD3_DTU_RD_BYTE14_SHIFT		16
#define ATLAS7_MEMC_DTURD3_DTU_RD_BYTE15_MASK		0xff
#define ATLAS7_MEMC_DTURD3_DTU_RD_BYTE15_SHIFT		24

/* fields for register ATLAS7_MEMC_DTULFSRWD */
#define ATLAS7_MEMC_DTULFSRWD_DTU_LFSR_WSEED_MASK		0xffffffff
#define ATLAS7_MEMC_DTULFSRWD_DTU_LFSR_WSEED_SHIFT		0

/* fields for register ATLAS7_MEMC_DTULFSRRD */
#define ATLAS7_MEMC_DTULFSRRD_DTU_LFSR_RSEED_MASK		0xffffffff
#define ATLAS7_MEMC_DTULFSRRD_DTU_LFSR_RSEED_SHIFT		0

/* fields for register ATLAS7_MEMC_DTUEAF */
#define ATLAS7_MEMC_DTUEAF_EA_COLUMN_MASK		0x3ff
#define ATLAS7_MEMC_DTUEAF_EA_COLUMN_SHIFT		0
#define ATLAS7_MEMC_DTUEAF_EA_BANK_MASK		0x7
#define ATLAS7_MEMC_DTUEAF_EA_BANK_SHIFT		10
#define ATLAS7_MEMC_DTUEAF_EA_ROW_MASK		0xffff
#define ATLAS7_MEMC_DTUEAF_EA_ROW_SHIFT		13
#define ATLAS7_MEMC_DTUEAF_EA_RANK_MASK		0x3
#define ATLAS7_MEMC_DTUEAF_EA_RANK_SHIFT		30

/* fields for register ATLAS7_MEMC_DFITCTRLDELAY */
#define ATLAS7_MEMC_DFITCTRLDELAY_TCTRL_DELAY_MASK		0xf
#define ATLAS7_MEMC_DFITCTRLDELAY_TCTRL_DELAY_SHIFT		0

/* fields for register ATLAS7_MEMC_DFIODTCFG */
#define ATLAS7_MEMC_DFIODTCFG_RANK0_ODT_READ_NSEL		BIT(0)
#define ATLAS7_MEMC_DFIODTCFG_RANK0_ODT_READ_SEL		BIT(1)
#define ATLAS7_MEMC_DFIODTCFG_RANK0_ODT_WRITE_NSEL		BIT(2)
#define ATLAS7_MEMC_DFIODTCFG_RANK0_ODT_WRITE_SEL		BIT(3)
#define ATLAS7_MEMC_DFIODTCFG_RANK0_ODT_DEFAULT		BIT(4)

/* fields for register ATLAS7_MEMC_DFIODTCFG1 */
#define ATLAS7_MEMC_DFIODTCFG1_ODT_LAT_W_MASK		0x1f
#define ATLAS7_MEMC_DFIODTCFG1_ODT_LAT_W_SHIFT		0
#define ATLAS7_MEMC_DFIODTCFG1_ODT_LAT_R_MASK		0x1f
#define ATLAS7_MEMC_DFIODTCFG1_ODT_LAT_R_SHIFT		8
#define ATLAS7_MEMC_DFIODTCFG1_ODT_LEN_BL8_W_MASK		0xf
#define ATLAS7_MEMC_DFIODTCFG1_ODT_LEN_BL8_W_SHIFT		16
#define ATLAS7_MEMC_DFIODTCFG1_ODT_LEN_B8_R_MASK		0xf
#define ATLAS7_MEMC_DFIODTCFG1_ODT_LEN_B8_R_SHIFT		24

/* fields for register ATLAS7_MEMC_DFIODTRANKMAP */
#define ATLAS7_MEMC_DFIODTRANKMAP_ODT_RANK_MAP0_MASK		0xf
#define ATLAS7_MEMC_DFIODTRANKMAP_ODT_RANK_MAP0_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITPHYWRDATA */
#define ATLAS7_MEMC_DFITPHYWRDATA_TPHY_WRDATA_MASK		0x3f
#define ATLAS7_MEMC_DFITPHYWRDATA_TPHY_WRDATA_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITPHYWRLAT */
#define ATLAS7_MEMC_DFITPHYWRLAT_TPHY_WRLAT_MASK		0x3f
#define ATLAS7_MEMC_DFITPHYWRLAT_TPHY_WRLAT_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITPHYWRDATALAT */
#define ATLAS7_MEMC_DFITPHYWRDATALAT_TPHY_WRDATA_LAT_MASK		0x3f
#define ATLAS7_MEMC_DFITPHYWRDATALAT_TPHY_WRDATA_LAT_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRDDATAEN */
#define ATLAS7_MEMC_DFITRDDATAEN_TRDDATA_EN_MASK		0x3f
#define ATLAS7_MEMC_DFITRDDATAEN_TRDDATA_EN_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITPHYRDLAT */
#define ATLAS7_MEMC_DFITPHYRDLAT_TPHY_RDLAT_MASK		0x3f
#define ATLAS7_MEMC_DFITPHYRDLAT_TPHY_RDLAT_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITPHYUPDTYPE0 */
#define ATLAS7_MEMC_DFITPHYUPDTYPE0_TPHYUPD_TYPE0_MASK		0x3fff
#define ATLAS7_MEMC_DFITPHYUPDTYPE0_TPHYUPD_TYPE0_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITPHYUPDTYPE1 */
#define ATLAS7_MEMC_DFITPHYUPDTYPE1_TPHYUPD_TYPE1_MASK		0x3fff
#define ATLAS7_MEMC_DFITPHYUPDTYPE1_TPHYUPD_TYPE1_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITPHYUPDTYPE2 */
#define ATLAS7_MEMC_DFITPHYUPDTYPE2_TPHYUPD_TYPE2_MASK		0x3fff
#define ATLAS7_MEMC_DFITPHYUPDTYPE2_TPHYUPD_TYPE2_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITPHYUPDTYPE3 */
#define ATLAS7_MEMC_DFITPHYUPDTYPE3_TPHYUPD_TYPE3_MASK		0x3fff
#define ATLAS7_MEMC_DFITPHYUPDTYPE3_TPHYUPD_TYPE3_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITCTRLUPDMIN */
#define ATLAS7_MEMC_DFITCTRLUPDMIN_TCTRLUPD_MIN_MASK		0xffff
#define ATLAS7_MEMC_DFITCTRLUPDMIN_TCTRLUPD_MIN_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITCTRLUPDMAX */
#define ATLAS7_MEMC_DFITCTRLUPDMAX_TCTRLUPD_MAX_MASK		0xffff
#define ATLAS7_MEMC_DFITCTRLUPDMAX_TCTRLUPD_MAX_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITCTRLUPDDLY */
#define ATLAS7_MEMC_DFITCTRLUPDDLY_TCTRLUPD_DLY_MASK		0xf
#define ATLAS7_MEMC_DFITCTRLUPDDLY_TCTRLUPD_DLY_SHIFT		0

/* fields for register ATLAS7_MEMC_DFIUPDCFG */
#define ATLAS7_MEMC_DFIUPDCFG_DFI_CTRLUPD_EN		BIT(0)
#define ATLAS7_MEMC_DFIUPDCFG_DFI_PHYUPD_EN		BIT(1)
#define ATLAS7_MEMC_DFIUPDCFG_DFI_CTRLUPD_EN_WK		BIT(2)

/* fields for register ATLAS7_MEMC_DFITREFMSKI */
#define ATLAS7_MEMC_DFITREFMSKI_TREFMSKI_MASK		0x1fff
#define ATLAS7_MEMC_DFITREFMSKI_TREFMSKI_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITCTRLUPDI */
#define ATLAS7_MEMC_DFITCTRLUPDI_TCTRLUPDI_MASK		0xffffffff
#define ATLAS7_MEMC_DFITCTRLUPDI_TCTRLUPDI_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRCFG0 */
#define ATLAS7_MEMC_DFITRCFG0_DFI_RDLVL_RANK_SEL_MASK		0xf
#define ATLAS7_MEMC_DFITRCFG0_DFI_RDLVL_RANK_SEL_SHIFT		0
#define ATLAS7_MEMC_DFITRCFG0_DFI_RDLVL_EDGE_MASK		0x1ff
#define ATLAS7_MEMC_DFITRCFG0_DFI_RDLVL_EDGE_SHIFT		4
#define ATLAS7_MEMC_DFITRCFG0_DFI_WRLVL_RANK_SEL_MASK		0xf
#define ATLAS7_MEMC_DFITRCFG0_DFI_WRLVL_RANK_SEL_SHIFT		16

/* fields for register ATLAS7_MEMC_DFITRSTAT0 */
#define ATLAS7_MEMC_DFITRSTAT0_DFI_RDLVL_MODE_MASK		0x3
#define ATLAS7_MEMC_DFITRSTAT0_DFI_RDLVL_MODE_SHIFT		0
#define ATLAS7_MEMC_DFITRSTAT0_DFI_RDLVL_GATE_MODE_MASK		0x3
#define ATLAS7_MEMC_DFITRSTAT0_DFI_RDLVL_GATE_MODE_SHIFT		8
#define ATLAS7_MEMC_DFITRSTAT0_DFI_WRLVL_MODE_MASK		0x3
#define ATLAS7_MEMC_DFITRSTAT0_DFI_WRLVL_MODE_SHIFT		16

/* fields for register ATLAS7_MEMC_DFITRWRLVLEN */
#define ATLAS7_MEMC_DFITRWRLVLEN_DFI_WRLVL_EN_MASK		0x1ff
#define ATLAS7_MEMC_DFITRWRLVLEN_DFI_WRLVL_EN_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRRDLVLEN */
#define ATLAS7_MEMC_DFITRRDLVLEN_DFI_RDLVL_EN_MASK		0x1ff
#define ATLAS7_MEMC_DFITRRDLVLEN_DFI_RDLVL_EN_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRRDLVLGATEEN */
#define ATLAS7_MEMC_DFITRRDLVLGATEEN_DFI_RDLVL_GATE_EN_MASK		0x1ff
#define ATLAS7_MEMC_DFITRRDLVLGATEEN_DFI_RDLVL_GATE_EN_SHIFT		0

/* fields for register ATLAS7_MEMC_DFISTSTAT0 */
#define ATLAS7_MEMC_DFISTSTAT0_DFI_INIT_COMPLETE		BIT(0)
#define ATLAS7_MEMC_DFISTSTAT0_DFI_INIT_START		BIT(1)
#define ATLAS7_MEMC_DFISTSTAT0_DFI_FREQ_RATIO_MASK		0x3
#define ATLAS7_MEMC_DFISTSTAT0_DFI_FREQ_RATIO_SHIFT		4
#define ATLAS7_MEMC_DFISTSTAT0_DFI_DATA_BYTE_DISABLE_MASK		0x1ff
#define ATLAS7_MEMC_DFISTSTAT0_DFI_DATA_BYTE_DISABLE_SHIFT		16

/* fields for register ATLAS7_MEMC_DFISTCFG0 */
#define ATLAS7_MEMC_DFISTCFG0_DFI_INIT_START		BIT(0)
#define ATLAS7_MEMC_DFISTCFG0_DFI_FREQ_RATIO_EN		BIT(1)
#define ATLAS7_MEMC_DFISTCFG0_DFI_DATA_BYTE_DISABLE_EN		BIT(2)

/* fields for register ATLAS7_MEMC_DFISTCFG1 */
#define ATLAS7_MEMC_DFISTCFG1_DFI_DRAM_CLK_DISABLE_EN		BIT(0)
#define ATLAS7_MEMC_DFISTCFG1_DFI_DRAM_CLK_DISABLE_EN_DPD		BIT(1)

/* fields for register ATLAS7_MEMC_DFITDRAMCLKEN */
#define ATLAS7_MEMC_DFITDRAMCLKEN_TDRAM_CLK_ENABLE_MASK		0xf
#define ATLAS7_MEMC_DFITDRAMCLKEN_TDRAM_CLK_ENABLE_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITDRAMCLKDIS */
#define ATLAS7_MEMC_DFITDRAMCLKDIS_TDRAM_CLK_DISABLE_MASK		0xf
#define ATLAS7_MEMC_DFITDRAMCLKDIS_TDRAM_CLK_DISABLE_SHIFT		0

/* fields for register ATLAS7_MEMC_DFISTCFG2 */
#define ATLAS7_MEMC_DFISTCFG2_PARITY_INTR_EN		BIT(0)
#define ATLAS7_MEMC_DFISTCFG2_PARITY_EN		BIT(1)

/* fields for register ATLAS7_MEMC_DFISTPARCLR */
#define ATLAS7_MEMC_DFISTPARCLR_PARITY_INTR_CLR		BIT(0)
#define ATLAS7_MEMC_DFISTPARCLR_PARITY_LOG_CLR		BIT(1)

/* fields for register ATLAS7_MEMC_DFISTPARLOG */
#define ATLAS7_MEMC_DFISTPARLOG_PARITY_ERR_CNT_MASK		0xffffffff
#define ATLAS7_MEMC_DFISTPARLOG_PARITY_ERR_CNT_SHIFT		0

/* fields for register ATLAS7_MEMC_DFILPCFG0 */
#define ATLAS7_MEMC_DFILPCFG0_DFI_LP_EN_PD		BIT(0)
#define ATLAS7_MEMC_DFILPCFG0_DFI_LP_WAKEUP_PD_MASK		0xf
#define ATLAS7_MEMC_DFILPCFG0_DFI_LP_WAKEUP_PD_SHIFT		4
#define ATLAS7_MEMC_DFILPCFG0_DFI_LP_EN_SR		BIT(8)
#define ATLAS7_MEMC_DFILPCFG0_DFI_LP_WAKEUP_SR_MASK		0xf
#define ATLAS7_MEMC_DFILPCFG0_DFI_LP_WAKEUP_SR_SHIFT		12
#define ATLAS7_MEMC_DFILPCFG0_DFI_TLP_RESP_MASK		0xf
#define ATLAS7_MEMC_DFILPCFG0_DFI_TLP_RESP_SHIFT		16
#define ATLAS7_MEMC_DFILPCFG0_DFI_LP_EN_DPD		BIT(24)
#define ATLAS7_MEMC_DFILPCFG0_DFI_LP_WAKEUP_DPD_MASK		0xf
#define ATLAS7_MEMC_DFILPCFG0_DFI_LP_WAKEUP_DPD_SHIFT		28

/* fields for register ATLAS7_MEMC_DFITRWRLVLRESP0 */
#define ATLAS7_MEMC_DFITRWRLVLRESP0_DFI_WRLVL_RESP0_MASK 0xffffffff
#define ATLAS7_MEMC_DFITRWRLVLRESP0_DFI_WRLVL_RESP0_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRWRLVLRESP1 */
#define ATLAS7_MEMC_DFITRWRLVLRESP1_DFI_WRLVL_RESP1_MASK 0xffffffff
#define ATLAS7_MEMC_DFITRWRLVLRESP1_DFI_WRLVL_RESP1_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRWRLVLRESP2 */
#define ATLAS7_MEMC_DFITRWRLVLRESP2_DFI_WRLVL_RESP2_MASK		0xff
#define ATLAS7_MEMC_DFITRWRLVLRESP2_DFI_WRLVL_RESP2_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRRDLVLRESP0 */
#define ATLAS7_MEMC_DFITRRDLVLRESP0_DFI_RDLVL_RESP0_MASK 0xffffffff
#define ATLAS7_MEMC_DFITRRDLVLRESP0_DFI_RDLVL_RESP0_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRRDLVLRESP1 */
#define ATLAS7_MEMC_DFITRRDLVLRESP1_DFI_RDLVL_RESP1_MASK 0xffffffff
#define ATLAS7_MEMC_DFITRRDLVLRESP1_DFI_RDLVL_RESP1_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRRDLVLRESP2 */
#define ATLAS7_MEMC_DFITRRDLVLRESP2_DFI_RDLVL_RESP2_MASK		0xff
#define ATLAS7_MEMC_DFITRRDLVLRESP2_DFI_RDLVL_RESP2_SHIFT		0

/* fields for register ATLAS7_MEMC_DFITRWRLVLDELAY0 */
#define ATLAS7_MEMC_DFITRWRLVLDELAY0_DFI_WRLVL_DELAY0		BIT(0)

/* fields for register ATLAS7_MEMC_DFITRRDLVLDELAY0 */
#define ATLAS7_MEMC_DFITRRDLVLDELAY0_DFI_RDLVL_DELAY0		BIT(0)

/* fields for register ATLAS7_MEMC_DFITRRDLVLGATEDELAY0 */
#define ATLAS7_MEMC_DFITRRDLVLGATEDELAY0_DFI_RDLVL_GATE_DELAY0 BIT(0)

/* fields for register ATLAS7_MEMC_DFITRCMD */
#define ATLAS7_MEMC_DFITRCMD_DFITRCMD_OPCODE_MASK		0x3
#define ATLAS7_MEMC_DFITRCMD_DFITRCMD_OPCODE_SHIFT		0
#define ATLAS7_MEMC_DFITRCMD_DFITRCMD_EN_MASK		0x1ff
#define ATLAS7_MEMC_DFITRCMD_DFITRCMD_EN_SHIFT		4
#define ATLAS7_MEMC_DFITRCMD_DFITRCMD_START		BIT(31)

/* fields for register ATLAS7_MEMC_IPVR */
#define ATLAS7_MEMC_IPVR_IP_VERSION_MASK		0xffffffff
#define ATLAS7_MEMC_IPVR_IP_VERSION_SHIFT		0

/* fields for register ATLAS7_MEMC_IPTR */
#define ATLAS7_MEMC_IPTR_IP_TYPE_MASK		0xffffffff
#define ATLAS7_MEMC_IPTR_IP_TYPE_SHIFT		0
